//////////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 

//////////////////////////////////////////////////////////////////////////////////

//define for apSetFunction
#define ap_Set_Split	170
#define ap_Set_Merge	175
#define ap_Set_Log		172

//define for apGetFunction
#define ap_Get_PageCount 206


//////////////////////////////////////////////////////////////////////////////////

typedef long (__stdcall *apOpenSplit)(char *In);
typedef long (__stdcall *apCreateMerge)(char *In);
typedef void (__stdcall *apClose)(long id);
typedef long (__stdcall *apSetFunction)(long id,long func_code,long para1,long para2,char *para3,char *para4);
typedef long (__stdcall *apGetFunction)(long id,long func_code,long para1,long para2,char *para3,char *para4);
typedef long (__stdcall *apAddInfo)(long id,char *Title,char *Subject,char *Author,char *Keywords,char *Creator);

//////////////////////////////////////////////////////////////////////////////////

HMODULE			g_hapW=NULL;

apOpenSplit		fnOpenSplit;
apCreateMerge	fnCreateMerge;
apClose			fnClose;
apSetFunction	fnSetFunction;
apGetFunction	fnGetFunction;
apAddInfo		fnAddInfo;

//////////////////////////////////////////////////////////////////////////////////

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadapWDll(void);
void	FreeapWDll();

//////////////////////////////////////////////////////////////////////////////////

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,512);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL LoadapWDll()
{
	char path[512];
	GetModulePath(path,"pdfspme.dll");
	g_hapW=LoadLibrary(path);
	if(g_hapW==NULL)
		goto Failer;

	fnOpenSplit=(apOpenSplit)GetProcAddress(g_hapW,"apOpenSplit");
	if(fnOpenSplit==NULL)
		goto Failer;
	fnCreateMerge=(apCreateMerge)GetProcAddress(g_hapW,"apCreateMerge");
	if(fnCreateMerge==NULL)
		goto Failer;
	fnClose=(apClose)GetProcAddress(g_hapW,"apClose");
	if(fnClose==NULL)
		goto Failer;
	fnSetFunction=(apSetFunction)GetProcAddress(g_hapW,"apSetFunction");
	if(fnSetFunction==NULL)
		goto Failer;
	fnGetFunction=(apGetFunction)GetProcAddress(g_hapW,"apGetFunction");
	if(fnGetFunction==NULL)
		goto Failer;
	fnAddInfo=(apAddInfo)GetProcAddress(g_hapW,"apAddInfo");
	if(fnAddInfo==NULL)
		goto Failer;

	return TRUE;
Failer:
	FreeapWDll(); 
	return FALSE;
}

void FreeapWDll()
{
	if(g_hapW==NULL)
		return ;
	FreeLibrary(g_hapW);
	g_hapW=NULL;
}




void main()
{
	char szSrcPDFFile[512]="\0";
	char szDesPDFFile[512]="\0";
	char szRange[64]="2,4;1,3-4;2-3";
	long id;

	if(!LoadapWDll())
		return ;

	
	GetModulePath(szSrcPDFFile,"example.pdf");
	GetModulePath(szDesPDFFile,"example");
		
	id=fnOpenSplit(szSrcPDFFile); 
	if(id>0){
		fnAddInfo(id,"Title","Subject","Author","Keywords","Creator");
		fnSetFunction(id,ap_Set_Log,0,0,"log.log",0);
		fnSetFunction(id,ap_Set_Split,1,2,szRange,szDesPDFFile);
		fnClose(id);         
	}
	

	GetModulePath(szSrcPDFFile,"example.pdf");
	GetModulePath(szDesPDFFile,"example_merge.pdf");

	id=fnCreateMerge(szDesPDFFile); 
	if(id>0){
		fnAddInfo(id,"Title","Subject","Author","Keywords","Creator");
		fnSetFunction(id,ap_Set_Log,0,0,"log.log",0);

		fnSetFunction(id,ap_Set_Merge,0,0,szSrcPDFFile,0);           
 		fnSetFunction(id,ap_Set_Merge,0,0,szSrcPDFFile,0);           

		fnClose(id);         
	}

	FreeapWDll();
}

